require "ATA2TuningTable"
-- local TemplateTuningTable = require "SVUC_TuningTable"
require "SVUC_TuningTable"

local function copy(obj, seen)
    if type(obj) ~= 'table' then
        return obj
    end
    if seen and seen[obj] then
        return seen[obj]
    end
    local s = seen or {}
    local res = setmetatable({}, getmetatable(obj))
    s[obj] = res
    for k, v in pairs(obj) do
        res[copy(k, s)] = copy(v, s)
    end
    return res
end

local function SVU_TuningTable()
    local TemplateTuningTable = SVUC_TemplateVehicle()
    local NewCarTuningTable = {}
    local TemplatesTuningTable = {}

    local carRecipe = "ATAVanillaRecipes"

    -- CarNormal
    TemplatesTuningTable["2DoorBase"] = {
        addPartsFromVehicleScript = "",
        parts = {}
    }
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionWindowFrontLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowFrontLeft"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionWindowFrontRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowFrontRight"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionWindshield"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindshield"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionWindshieldRear"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindshieldRear"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2Bullbar"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2Bullbar"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionHood"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionHood"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionDoorFrontLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorFrontLeft"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionDoorFrontRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorFrontRight"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2RoofLightFront"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2RoofLightFront"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2ProtectionWheels"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWheels"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2AirScoop"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2AirScoop"])
    TemplatesTuningTable["2DoorBase"].parts["ATA2Snorkel"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2Snorkel"])

    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionWindowFrontLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionWindowFrontRight")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionWindshield")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionWindshieldRear")
    SVUC_setVehicleRecipesBullbars(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2Bullbar")
    SVUC_setVehicleRecipesArmorHood(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionHood")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionDoorFrontLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionDoorFrontRight")
    SVUC_setVehicleRecipesWheels(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2ProtectionWheels")
    SVUC_setVehicleRecipesMods(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2RoofLightFront")
    SVUC_setVehicleRecipesScoops(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2AirScoop")
    SVUC_setVehicleRecipesSnorkels(TemplatesTuningTable, carRecipe, "2DoorBase", "ATA2Snorkel")

    TemplatesTuningTable["2DoorTrunkNoRack"] = copy(TemplatesTuningTable["2DoorBase"])
    TemplatesTuningTable["2DoorTrunkNoRack"].parts["ATA2ProtectionTrunk"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionTrunk"])
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorTrunkNoRack", "ATA2ProtectionTrunk")

    TemplatesTuningTable["4DoorTrunkNoRack"] = copy(TemplatesTuningTable["2DoorTrunkNoRack"])
    TemplatesTuningTable["4DoorTrunkNoRack"].parts["ATA2ProtectionWindowRearLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowRearLeft"])
    TemplatesTuningTable["4DoorTrunkNoRack"].parts["ATA2ProtectionWindowRearRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowRearRight"])
    TemplatesTuningTable["4DoorTrunkNoRack"].parts["ATA2ProtectionDoorRearLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorRearLeft"])
    TemplatesTuningTable["4DoorTrunkNoRack"].parts["ATA2ProtectionDoorRearRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorRearRight"])
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "4DoorTrunkNoRack", "ATA2ProtectionWindowRearLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "4DoorTrunkNoRack", "ATA2ProtectionWindowRearRight")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "4DoorTrunkNoRack", "ATA2ProtectionDoorRearLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "4DoorTrunkNoRack", "ATA2ProtectionDoorRearRight")

    TemplatesTuningTable["4DoorTrunkSmallRack"] = copy(TemplatesTuningTable["4DoorTrunkNoRack"])
    TemplatesTuningTable["4DoorTrunkSmallRack"].parts["ATA2InteractiveTrunkRoofRack"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2InteractiveTrunkRoofRack"])
    TemplatesTuningTable["4DoorTrunkSmallRack"].parts["ATA2InteractiveTrunkRoofRack"].Default.containerCapacity = 50
    SVUC_setVehicleRecipesMods(TemplatesTuningTable, carRecipe, "4DoorTrunkSmallRack", "ATA2InteractiveTrunkRoofRack")

    TemplatesTuningTable["4DoorTrunkMedRack"] = copy(TemplatesTuningTable["4DoorTrunkNoRack"])
    TemplatesTuningTable["4DoorTrunkMedRack"].parts["ATA2InteractiveTrunkRoofRack"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2InteractiveTrunkRoofRack"])
    TemplatesTuningTable["4DoorTrunkMedRack"].parts["ATA2InteractiveTrunkRoofRack"].Default.containerCapacity = 100
    SVUC_setVehicleRecipesMods(TemplatesTuningTable, carRecipe, "4DoorTrunkMedRack", "ATA2InteractiveTrunkRoofRack")

    -- PickUpTruck = 2DoorTrunkNoRack

    -- PickUpVan = 2DoorTrunkMedRack
    TemplatesTuningTable["2DoorTrunkMedRack"] = copy(TemplatesTuningTable["2DoorTrunkNoRack"])
    TemplatesTuningTable["2DoorTrunkMedRack"].parts["ATA2InteractiveTrunkRoofRack"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2InteractiveTrunkRoofRack"])
    TemplatesTuningTable["2DoorTrunkMedRack"].parts["ATA2InteractiveTrunkRoofRack"].Default.containerCapacity = 100
    SVUC_setVehicleRecipesMods(TemplatesTuningTable, carRecipe, "2DoorTrunkMedRack", "ATA2InteractiveTrunkRoofRack")

    -- Small car
    TemplatesTuningTable["2DoorTrunkSmallRack"] = copy(TemplatesTuningTable["2DoorTrunkNoRack"])
    TemplatesTuningTable["2DoorTrunkSmallRack"].parts["ATA2InteractiveTrunkRoofRack"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2InteractiveTrunkRoofRack"])
    TemplatesTuningTable["2DoorTrunkSmallRack"].parts["ATA2InteractiveTrunkRoofRack"].Default.containerCapacity = 50
    SVUC_setVehicleRecipesMods(TemplatesTuningTable, carRecipe, "2DoorTrunkSmallRack", "ATA2InteractiveTrunkRoofRack")

    TemplatesTuningTable["2DoorRearWindowTrunkSmallRack"] = copy(TemplatesTuningTable["2DoorTrunkSmallRack"])
    TemplatesTuningTable["2DoorRearWindowTrunkSmallRack"].parts["ATA2ProtectionWindowRearLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowRearLeft"])
    TemplatesTuningTable["2DoorRearWindowTrunkSmallRack"].parts["ATA2ProtectionWindowRearRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowRearRight"])
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorRearWindowTrunkSmallRack",
        "ATA2ProtectionWindowRearLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "2DoorRearWindowTrunkSmallRack",
        "ATA2ProtectionWindowRearRight")

    -- Van
    TemplatesTuningTable["VanNoRack"] = copy(TemplatesTuningTable["2DoorBase"])
    TemplatesTuningTable["VanNoRack"].parts["ATA2ProtectionDoorsRear"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorsRear"])
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "VanNoRack", "ATA2ProtectionDoorsRear")

    TemplatesTuningTable["VanMedRack"] = copy(TemplatesTuningTable["VanNoRack"])
    TemplatesTuningTable["VanMedRack"].parts["ATA2InteractiveTrunkRoofRack"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2InteractiveTrunkRoofRack"])
    TemplatesTuningTable["VanMedRack"].parts["ATA2InteractiveTrunkRoofRack"].Default.containerCapacity = 100
    SVUC_setVehicleRecipesMods(TemplatesTuningTable, carRecipe, "VanMedRack", "ATA2InteractiveTrunkRoofRack")

    TemplatesTuningTable["VanSeatsMedRack"] = copy(TemplatesTuningTable["VanMedRack"])
    TemplatesTuningTable["VanSeatsMedRack"].parts["ATA2ProtectionWindowMiddleLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowMiddleLeft"])
    TemplatesTuningTable["VanSeatsMedRack"].parts["ATA2ProtectionWindowMiddleRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionWindowMiddleRight"])
    TemplatesTuningTable["VanSeatsMedRack"].parts["ATA2ProtectionDoorMiddleLeft"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorMiddleLeft"])
    TemplatesTuningTable["VanSeatsMedRack"].parts["ATA2ProtectionDoorMiddleRight"] = copy(
        TemplateTuningTable["TemplateVehicle"].parts["ATA2ProtectionDoorMiddleRight"])
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "VanSeatsMedRack", "ATA2ProtectionWindowMiddleLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "VanSeatsMedRack", "ATA2ProtectionWindowMiddleRight")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "VanSeatsMedRack", "ATA2ProtectionDoorMiddleLeft")
    SVUC_setVehicleRecipesArmor(TemplatesTuningTable, carRecipe, "VanSeatsMedRack", "ATA2ProtectionDoorMiddleRight")

    -- VVehicleEnhancer
    if getActivatedMods():contains("VVehicleEnhancer") then
        NewCarTuningTable["StepVanMailupz"] = TemplatesTuningTable["VanMedRack"]
    end

    ATA2Tuning_AddNewCars(NewCarTuningTable)
end

Events.OnInitGlobalModData.Add(SVU_TuningTable)
